#include "H/Function_Init.H"

void ADC_Init(uint Channel,uchar ADCFreq);
unsigned int ADC_AverageValue(void);
unsigned int ADCValue = 0x0000;
bit AdcFlag = 0;
/***********ADCƵѡ*************/
enum ADCFreq {F32=0,F24,F16,F12,F8,F6,F4,F3};

/***********ADCѡ*************/
#if (IC_MODEL == SC92F8413B)
enum Channel {AIN0=0,AIN1,AIN2,AIN3,AIN4,AIN5,AIN6,AIN7,AIN8,AIN9,VDD4=31};
#endif

#if (IC_MODEL == SC92F8419B)
enum Channel {AIN0=0,AIN1,AIN2,AIN3,AIN4,AIN5,AIN8=8,AIN9,VDD4=31};
#endif

#if (IC_MODEL == SC92F8412B)
enum Channel {AIN2=2,AIN3,AIN4,AIN5,AIN8=8,AIN9,VDD4=31};
#endif

#if (IC_MODEL == SC92F8411B)
enum Channel {AIN2=2,AIN3,AIN4,AIN8=8,AIN9,VDD4=31};
#endif

/*****************************************************
*ƣvoid ADC_Test(void)
*ܣADC
*ڲvoid
*ڲvoid
*****************************************************/
void ADC_Test(void)
{
	ADC_Init(AIN2,F8);
	while(1)
	{
		 ADCValue = ADC_AverageValue();
	}
}
/*****************************************************
*ƣvoid ADC_Init(uint Channel,uchar ADCFreq)
*ܣADCʼ
*ڲvoid
*ڲvoid
*****************************************************/
void ADC_Init(uint Channel,uchar ADCFreq)
{
	ADCCON = 0X80|Channel;		//ADCѡChannelλADC
	if(Channel<8)
	{
		ADCCFG0 = 1<<Channel;   //ChannelΪ
	}
	else
	{
		ADCCFG1 = 1<<(Channel-8);   //ChannelΪ
	}
	ADCCFG2 = ADCFreq;
	IE |= 0X40;        //ADCж
	EA = 1;
}

unsigned int ADC_AverageValue()
{
	int i = 0; 
	unsigned int ADC_ValueSum = 0, ADC_ValueMax = 0 ,ADC_ValueMin = 0x01 << 12 ,ADC_ValueMean = 0 ,ADC_ValueTad = 0;
	for(i=0;i<10;i++ )
	{	
		ADCCON |= 0X40;   //ʼADCת
	  while(!AdcFlag);	         		 //ȴ ADCת;
		AdcFlag = 0;
		ADC_ValueTad = (ADCVH<<4)+(ADCVL>>4);
		if(ADC_ValueTad>ADC_ValueMax)
		{
		 ADC_ValueMax = ADC_ValueTad;
		}
		if(ADC_ValueTad<ADC_ValueMin)
		{
		 ADC_ValueMin = ADC_ValueTad;
		}
		ADC_ValueSum += ADC_ValueTad;
	}
	ADC_ValueMean = (unsigned int)((ADC_ValueSum - ADC_ValueMax - ADC_ValueMin) / 8);
  return ADC_ValueMean;
}

void ADC_Interrupt(void) interrupt 6
{
	ADCCON&=~(0X20);  //жϱ־λ
	AdcFlag = 1;
}